package fr.unistra.sil.erp.back.service;

import fr.unistra.sil.erp.back.model.Item;
import fr.unistra.sil.erp.back.repository.IItemsRepository;
import org.springframework.stereotype.Service;

/**
 *
 * @author antoine.beauvais
 */
@Service
public class StoreItemService {
    private final IItemsRepository repository;

    /**
     *
     * @param repository
     */
    public StoreItemService(IItemsRepository repository) {
        this.repository = repository;
    }

    /**
     *
     * @param request
     * @return
     * @throws CantStoreItemException
     */
    public Item store(StoreItemRequest request) throws CantStoreItemException {
        Item stored = repository.store(new Item(
                null,
                request.getName(),
                request.getPrice(),
                request.getSubscriberPrice(),
                request.getCategory()
        ));
        if (stored == null) {
            throw new CantStoreItemException();
        }
        return stored;
    }
}
